clan::TextFieldView Class Reference - ClanLib SDK
Description: clan::TextFieldView Class Reference

Public Member Functions | Protected Member Functions | List of all members
clan::TextFieldView Class Reference

`#include <text_field_view.h>`

Inheritance diagram for clan::TextFieldView:

## Public Member Functions
| TextFieldView ()
| ~TextFieldView () override
void | clear_selection ()
int | cursor_pos () const
void | delete_selected_text ()
bool | is_lowercase () const
bool | is_password_mode () const
bool | is_read_only () const
bool | is_uppercase () const
int | max_length () const
void | needs_render_delayed ()
| Update yourself with draw_without_layout() and with delay to prevent too frequent calls.
std::string | placeholder () const
int | preferred_size () const
void | select_all ()
std::string | selection () const
size_t | selection_length () const
size_t | selection_start () const
void | set_cursor_drawing_enabled (bool value)
void | set_cursor_pos (int pos)
void | set_decimal_character (const std::string &decimal_char)
void | set_input_mask (const std::string &mask)
void | set_lowercase (bool value=true)
void | set_max_length (int length)
void | set_numeric_mode (bool enable=true, bool decimals=false)
void | set_password_mode (bool value=true)
void | set_placeholder (const std::string &value)
void | set_preferred_size (int num_characters)
void | set_read_only (bool value=true)
void | set_select_all_on_focus_gain (bool value)
void | set_selection (size_t pos, size_t length)
void | set_text (const std::string &value)
void | set_text (float number, int num_decimal_places=6)
void | set_text (int number)
void | set_text_alignment (TextAlignment value)
void | set_uppercase (bool value=true)
Signal< void(KeyEvent &)> & | sig_after_edit_changed ()
Signal< void(KeyEvent &)> & | sig_before_edit_changed ()
Signal< void()> & | sig_enter_pressed ()
Signal< void()> & | sig_selection_changed ()
std::string | text () const
TextAlignment | text_alignment () const
float | text_float () const
int | text_int () const
Public Member Functions inherited from clan::View
| View ()
virtual | ~View ()
const std::vector< std::shared_ptr< ViewAction > > & | actions () const
| List of all action recognizers.
void | add_action (const std::shared_ptr< ViewAction > &action)
| Add an action recognizer.
template<typename T, typename... Types>
std::shared_ptr< T > | add_action (Types &&... args)
std::shared_ptr< View > | add_child ()
void | add_child (const std::shared_ptr< View > &view)
| Add a child view.
template<typename T, typename... Types>
std::shared_ptr< T > | add_child (Types &&... args)
void | animate (float from, float to, const std::function< void(float)> &setter, int duration_ms=400, const std::function< float(float)> &easing=Easing::linear, std::function< void()> animation_end=std::function< void()>())
| Continously call an animation function for the specified duration.
Canvas | canvas () const
const std::vector< std::shared_ptr< View > > & | children () const
| List of all immediate child views.
void | clear_exception_encountered ()
bool | content_clipped () const
| Content clipping flag.
float | definite_height ()
| The content height used for percentages or other definite calculations.
float | definite_width ()
| The content width used for percentages or other definite calculations.
void | draw_without_layout ()
| Render view and its children directly, without re-layout.
std::shared_ptr< View > | find_view_at (const Pointf &pos) const
| Find descendant view at the specified content relative position.
float | first_baseline_offset (Canvas &canvas, float width)
| Calculates the offset to the first baseline.
FocusPolicy | focus_policy () const
| Focus policy active for this view.
View * | focus_view () const
| The view receiving keyboard events or nullptr if no view has the focus.
Pointf | from_root_pos (const Pointf &pos)
| Map from root content to local content coordinates.
Pointf | from_screen_pos (const Pointf &pos)
| Map from screen to local content coordinates.
const ViewGeometry & | geometry () const
| Actual view position and size after layout.
bool | has_focus () const
| Test if this view is receiving keyboard input.
bool | hidden () const
| Test if view is set to hidden.
bool | is_height_definite ()
| Test if the view has a definite height.
bool | is_static_position_and_visible () const
| Test if view should participate in static layout calculations (layout_children).
bool | is_width_definite ()
| Test if the view has a definite width.
float | last_baseline_offset (Canvas &canvas, float width)
| Calculates the offset to the last baseline.
virtual void | layout_children (Canvas &canvas)
| Sets the view geometry for all children of this view.
bool | needs_layout () const
| Test if view geometry needs to be recalculated.
void | next_focus ()
| Give focus to the next view in the keyboard tab index order.
View * | parent () const
| Parent view node or nullptr if the view is the current root node.
float | preferred_height (Canvas &canvas, float width)
| Calculates the preferred height of this view.
float | preferred_width (Canvas &canvas)
| Calculates the preferred width of this view.
void | prev_focus ()
| Give focus to the previous view in the keyboard tab index order.
void | remove_focus ()
| Remove focus from this view.
void | remove_from_parent ()
| Remove view from parent.
bool | render_exception_encountered () const
| Test if this view generated an exception during rendering.
void | set_content_clipped (bool clipped)
| Specifies if content should be clipped during rendering.
void | set_cursor (const CursorDescription &cursor)
| Set the cursor icon used when cursor is above this view.
void | set_cursor (StandardCursor type)
void | set_focus ()
| Set this view as the focused view.
void | set_focus_policy (FocusPolicy policy)
| Set if this view automatically can gain focus.
void | set_geometry (const ViewGeometry &geometry)
void | set_hidden (bool value=true)
| Hides a view from layout and rendering.
void | set_inherit_cursor ()
| Specify that the cursor icon is inherited from the parent view.
void | set_needs_layout ()
| Forces recalculation of view geometry before next rendering.
void | set_needs_render ()
| Signals this view needs to be rendered again.
void | set_state (const std::string &name, bool value)
| Set or clear style state.
void | set_state_cascade (const std::string &name, bool value)
| Sets the state for this view and all children recursively, until a manually set state of the same name is found.
void | set_tab_index (unsigned int index)
| Sets the tab index used for keyboard focus changes.
void | set_view_transform (const Mat4f &transform)
| Specifies the view transform to be applied before its contents and children are rendered.
Signal< void(ActivationChangeEvent &)> & | sig_activated (bool use_capture=false)
| Window activated event.
Signal< void(CloseEvent &)> & | sig_close (bool use_capture=false)
| Window close button clicked event.
Signal< void(ActivationChangeEvent &)> & | sig_deactivated (bool use_capture=false)
| Window deactivated event.
Signal< void(FocusChangeEvent &)> & | sig_focus_gained (bool use_capture=false)
| View gained focus event.
Signal< void(FocusChangeEvent &)> & | sig_focus_lost (bool use_capture=false)
| View lost focus event.
Signal< void(KeyEvent &)> & | sig_key_press (bool use_capture=false)
| Key pressed event.
Signal< void(KeyEvent &)> & | sig_key_release (bool use_capture=false)
| Key released event.
Signal< void(PointerEvent &)> & | sig_pointer_double_click (bool use_capture=false)
| Pointer button double clicked event.
Signal< void(PointerEvent &)> & | sig_pointer_enter (bool use_capture=false)
| Pointer entering view geometry event.
Signal< void(PointerEvent &)> & | sig_pointer_leave (bool use_capture=false)
| Pointer leaving view geometry event.
Signal< void(PointerEvent &)> & | sig_pointer_move (bool use_capture=false)
| Pointer moved above view event.
Signal< void(PointerEvent &)> & | sig_pointer_press (bool use_capture=false)
| Pointer button pressed event.
Signal< void(PointerEvent &)> & | sig_pointer_proximity_change (bool use_capture=false)
| Pointer proximity change event.
Signal< void(PointerEvent &)> & | sig_pointer_release (bool use_capture=false)
| Pointer button released event.
Signal< void(ResizeEvent &)> & | sig_resize (bool use_capture=false)
| Window resize event.
bool | state (const std::string &name) const
| Test if a style state is currently set.
void | stop_animations ()
| Stop all activate animation functions.
const std::shared_ptr< Style > & | style (const std::string &state=std::string()) const
| Style properties for the specified state.
const StyleCascade & | style_cascade () const
| Style cascade currently active for this view.
unsigned int | tab_index () const
| Tab index for keyboard focus changes.
Pointf | to_root_pos (const Pointf &pos, bool relative_to_margin=false)
| Map from local content to root content or margin (plus content, padding, border and margin) coordinates.
Pointf | to_screen_pos (const Pointf &pos)
| Map from local content to screen coordinates.
void | update_cursor (DisplayWindow &window)
| Update window cursor to the cursor used by this view.
const Mat4f & | view_transform () const
| Current view transform.
ViewTree * | view_tree ()
const ViewTree * | view_tree () const
| Tree in view hierachy.

## Protected Member Functions
float | calculate_first_baseline_offset (Canvas &canvas, float width) override
| Calculates the offset to the first baseline.
float | calculate_last_baseline_offset (Canvas &canvas, float width) override
| Calculates the offset to the last baseline.
float | calculate_preferred_height (Canvas &canvas, float width) override
| Calculates the preferred height of this view.
float | calculate_preferred_width (Canvas &canvas) override
| Calculates the preferred width of this view.
void | render_content (Canvas &canvas) override
| Renders the content of a view.
Protected Member Functions inherited from clan::View
virtual float | calculate_definite_height (bool &out_is_definite)
| The content height used for percentages or other definite calculations.
virtual float | calculate_definite_width (bool &out_is_definite)
| The content width used for percentages or other definite calculations.
virtual void | child_added (const std::shared_ptr< View > &view)
| Child view was added to this view.
virtual void | child_removed (const std::shared_ptr< View > &view)
| Child view was removed from this view.
virtual void | render_background (Canvas &canvas)
| Renders the background of a view.
virtual void | render_border (Canvas &canvas)
| Renders the border of a view.
virtual void | updated_view_tree ()

## Additional Inherited Members
Static Public Member Functions inherited from clan::View
static void | dispatch_event (View *target, EventUI *e, bool no_propagation=false)
| Dispatch event to signals listening for events.
Public Attributes inherited from clan::View
SlotContainer | slots
| Slot container helping with automatic disconnection of connected slots when the view is destroyed.

## Constructor & Destructor Documentation

## ◆ TextFieldView()

clan::TextFieldView::TextFieldView | ( |  | ) |

## ◆ ~TextFieldView()

clan::TextFieldView::~TextFieldView | ( |  | ) |
| override

## Member Function Documentation

## ◆ calculate_first_baseline_offset()

float clan::TextFieldView::calculate_first_baseline_offset | ( | Canvas & | canvas,
|  | float | width )
| overrideprotectedvirtual

Calculates the offset to the first baseline.

Reimplemented from clan::View.

References clan::View::canvas().

## ◆ calculate_last_baseline_offset()

float clan::TextFieldView::calculate_last_baseline_offset | ( | Canvas & | canvas,
|  | float | width )
| overrideprotectedvirtual

Calculates the offset to the last baseline.

Reimplemented from clan::View.

References clan::View::canvas().

## ◆ calculate_preferred_height()

float clan::TextFieldView::calculate_preferred_height | ( | Canvas & | canvas,
|  | float | width )
| overrideprotectedvirtual

Calculates the preferred height of this view.

Reimplemented from clan::View.

References clan::View::canvas().

## ◆ calculate_preferred_width()

float clan::TextFieldView::calculate_preferred_width | ( | Canvas & | canvas | ) |
| overrideprotectedvirtual

Calculates the preferred width of this view.

Reimplemented from clan::View.

References clan::View::canvas().

## ◆ clear_selection()

void clan::TextFieldView::clear_selection | ( |  | ) |

## ◆ cursor_pos()

int clan::TextFieldView::cursor_pos | ( |  | ) | const

## ◆ delete_selected_text()

void clan::TextFieldView::delete_selected_text | ( |  | ) |

## ◆ is_lowercase()

bool clan::TextFieldView::is_lowercase | ( |  | ) | const

## ◆ is_password_mode()

bool clan::TextFieldView::is_password_mode | ( |  | ) | const

## ◆ is_read_only()

bool clan::TextFieldView::is_read_only | ( |  | ) | const

## ◆ is_uppercase()

bool clan::TextFieldView::is_uppercase | ( |  | ) | const

## ◆ max_length()

int clan::TextFieldView::max_length | ( |  | ) | const

## ◆ needs_render_delayed()

void clan::TextFieldView::needs_render_delayed | ( |  | ) |

Update yourself with draw_without_layout() and with delay to prevent too frequent calls.

## ◆ placeholder()

std::string clan::TextFieldView::placeholder | ( |  | ) | const

## ◆ preferred_size()

int clan::TextFieldView::preferred_size | ( |  | ) | const

## ◆ render_content()

void clan::TextFieldView::render_content | ( | Canvas & | canvas | ) |
| overrideprotectedvirtual

Renders the content of a view.

Reimplemented from clan::View.

References clan::View::canvas().

## ◆ select_all()

void clan::TextFieldView::select_all | ( |  | ) |

## ◆ selection()

std::string clan::TextFieldView::selection | ( |  | ) | const

## ◆ selection_length()

size_t clan::TextFieldView::selection_length | ( |  | ) | const

## ◆ selection_start()

size_t clan::TextFieldView::selection_start | ( |  | ) | const

## ◆ set_cursor_drawing_enabled()

void clan::TextFieldView::set_cursor_drawing_enabled | ( | bool | value | ) |

## ◆ set_cursor_pos()

void clan::TextFieldView::set_cursor_pos | ( | int | pos | ) |

## ◆ set_decimal_character()

void clan::TextFieldView::set_decimal_character | ( | const std::string & | decimal_char | ) |

## ◆ set_input_mask()

void clan::TextFieldView::set_input_mask | ( | const std::string & | mask | ) |

## ◆ set_lowercase()

void clan::TextFieldView::set_lowercase | ( | bool | value = true | ) |

## ◆ set_max_length()

void clan::TextFieldView::set_max_length | ( | int | length | ) |

## ◆ set_numeric_mode()

void clan::TextFieldView::set_numeric_mode | ( | bool | enable = true,
|  | bool | decimals = false )

## ◆ set_password_mode()

void clan::TextFieldView::set_password_mode | ( | bool | value = true | ) |

## ◆ set_placeholder()

void clan::TextFieldView::set_placeholder | ( | const std::string & | value | ) |

## ◆ set_preferred_size()

void clan::TextFieldView::set_preferred_size | ( | int | num_characters | ) |

## ◆ set_read_only()

void clan::TextFieldView::set_read_only | ( | bool | value = true | ) |

## ◆ set_select_all_on_focus_gain()

void clan::TextFieldView::set_select_all_on_focus_gain | ( | bool | value | ) |

## ◆ set_selection()

void clan::TextFieldView::set_selection | ( | size_t | pos,
|  | size_t | length )

## ◆ set_text() [1/3]

void clan::TextFieldView::set_text | ( | const std::string & | value | ) |

## ◆ set_text() [2/3]

void clan::TextFieldView::set_text | ( | float | number,
|  | int | num_decimal_places = 6 )

## ◆ set_text() [3/3]

void clan::TextFieldView::set_text | ( | int | number | ) |

## ◆ set_text_alignment()

void clan::TextFieldView::set_text_alignment | ( | TextAlignment | value | ) |

## ◆ set_uppercase()

void clan::TextFieldView::set_uppercase | ( | bool | value = true | ) |

## ◆ sig_after_edit_changed()

Signal< void(KeyEvent &)> & clan::TextFieldView::sig_after_edit_changed | ( |  | ) |

## ◆ sig_before_edit_changed()

Signal< void(KeyEvent &)> & clan::TextFieldView::sig_before_edit_changed | ( |  | ) |

## ◆ sig_enter_pressed()

Signal< void()> & clan::TextFieldView::sig_enter_pressed | ( |  | ) |

## ◆ sig_selection_changed()

Signal< void()> & clan::TextFieldView::sig_selection_changed | ( |  | ) |

## ◆ text()

std::string clan::TextFieldView::text | ( |  | ) | const

## ◆ text_alignment()

TextAlignment clan::TextFieldView::text_alignment | ( |  | ) | const

## ◆ text_float()

float clan::TextFieldView::text_float | ( |  | ) | const

## ◆ text_int()

int clan::TextFieldView::text_int | ( |  | ) | const

The documentation for this class was generated from the following file:

- text_field_view.h